  MEMBER
!
! Version 2.1
!
  INCLUDE('fauxMax.inc'),ONCE

FAUX_RECT                      GROUP,TYPE
Left                              SIGNED
Top                               SIGNED
Right                             SIGNED
Bottom                            SIGNED
                                End
  MAP
    MODULE('winApi')
      FAUX_SetWindowText(FAUX_HWND,*LPCSTR),BOOL,RAW,PASCAL,PROC,NAME('SetWindowTextA')
      FAUX_GetWindowRect(FAUX_HWND hWnd, *FAUX_RECT lpRect),BOOL,Raw,Pascal,Proc,Name('GetWindowRect')
      FAUX_GetParent(FAUX_HWND hWnd),FAUX_HWND,Pascal,Name('GetParent')
      FAUX_MoveWindow(FAUX_HWND hWnd, UNSIGNED x, UNSIGNED y, UNSIGNED cx, UNSIGNED cy, BOOL bRedraw),BOOL,Pascal,Proc,Name('MoveWindow')
    END
  END

FauxMaxClass.Init        Procedure(WINDOW W, <*WindowResizeClass WRC>, *CSTRING inFrameTitle, SIGNED inXPos, SIGNED inYPos, SIGNED inWidth, SIGNED inHeight, Long bWatchMDIChildMax=True, *BYTE inMaximize, BYTE inBorder, LONG inFeqFauxImage, BYTE inScroll=0)
feq       LONG

  Code
  
  SELF.W &= W

  IF NOT OMITTED(WRC)
     SELF.WRC &= WRC
  END

  SELF.OrigXPos   = inXPos
  SELF.OrigYPos   = inYPos
  SELF.OrigWidth  = inWidth
  SELF.OrigHeight = inHeight
  SELF.OrigTitle  = inFrameTitle
  SELF.MDIBorder  = inBorder
  SELF.HScroll    = BAND(inScroll,2)
  SELF.VScroll    = BAND(inScroll,1)
    
  SELF.GlobalMaximize &= inMaximize

  IF W{PROP:MDI} AND W{PROP:Resize} AND W{PROP:Max}
  
    SELF.hWnd = W{PROP:Handle}

    ! Create the image control used to identify the Restore "button" for the window
    feq = CREATE(0,CREATE:Image)
    IF feq
      SETPOSITION(feq,0{PROP:Width}-10,0,10,10)
      SELF.FauxButton = feq
    END

    ! Create the region control to handle the sizing events registered in the FauxMax class
    feq = CREATE(0,CREATE:Region)
    IF feq
      SETPOSITION(feq,0{PROP:Width}-10,0,10,10)
      SELF.FauxHandle = feq
    END
    
    CASE SELF.MDIBorder
    OF 1 ! Thin border
      SELF.ltborder = 2; SELF.tpBorder = 28; SELF.rtBorder = 4; SELF.bmBorder = 31
    OF 2 ! Double border
      SELF.ltborder = 0; SELF.tpBorder = 26; SELF.rtBorder = 0; SELF.bmBorder = 26
    OF 3 ! Title and resizable border ! Classic FauxMax
      SELF.ltborder = 0; SELF.tpBorder = 0; SELF.rtBorder = 0; SELF.bmBorder = 0
      SELF.HScroll    = FALSE   ! turn off scroll handling
      SELF.VScroll    = FALSE   ! turn off scroll handling
    ELSE ! no border
      SELF.ltborder = 4; SELF.tpBorder = 30; SELF.rtBorder = 8; SELF.bmBorder = 35
    END
        
    REGISTER(Event:Maximize, ADDRESS(SELF.OnMaximize), ADDRESS(SELF), W)
    REGISTER(Event:FrameResize, ADDRESS(SELF.OnResize), ADDRESS(SELF), W)
    
    IF bWatchMDIChildMax
       REGISTER(Event:MDIChildMaximize, ADDRESS(SELF.OnUserMaximize), ADDRESS(SELF), W)
    End
    
    IF (inMaximize = 1)
       POST(Event:Maximize,,,True)
    END
    
  ELSE
  
    SELF.MyMaximize = inMaximize
    
  END
  
  RETURN

FauxMaxClass.OnUserMaximize   Procedure()!,Byte,Protected,Proc

  CODE
  
  RETURN SELF.OnMaximize()
  
FauxMaxClass.GetMaximize Procedure()!,BYTE

  CODE
  
  RETURN(SELF.MyMaximize)

FauxMaxClass.OnMaximize    Procedure()!,Byte,Protected,Proc

rcFCA       Like(FAUX_RECT)
szWinTitle  CSTRING(192)

   CODE
   
   If SELF.W{PROP:Iconize}
      SELF.W{PROP:Iconize} = False
   End

   FAUX_GetWindowRect(FAUX_GetParent(SELF.hWnd), rcFCA)

   IF (SELF.MyMaximize = 0)
      IF SELF.MDIBorder<>3
        szWinTitle = SELF.OrigTitle & ' - ' & SELF.W{PROP:Text}
        FAUX_SetWindowText(FAUX_GetParent(FAUX_GetParent(SELF.hWnd)),szWinTitle)
        UNHIDE(SELF.FauxButton,SELF.FauxHandle)
        IF SELF.VScroll THEN POST(EVENT:VScrollOff,0,1,TRUE).
        IF SELF.HScroll THEN POST(EVENT:HScrollOff,0,1,TRUE).
      END

      FAUX_MoveWindow(SELF.hWnd, -SELF.ltBorder, -SELF.tpBorder, (rcFCA.Right - rcFCA.Left + SELF.rtBorder), (rcFCA.Bottom - rcFCA.Top + SELF.bmBorder), True)
      
      SELF.MyMaximize = 1 ; SELF.GlobalMaximize = 1
   ELSE
      HIDE(SELF.FauxButton,SELF.FauxHandle)
   
      SETPOSITION(0, SELF.OrigXPos, SELF.OrigYPos, SELF.OrigWidth, SELF.OrigHeight) 

      IF SELF.MDIBorder<>3
        szWinTitle = SELF.OrigTitle
        FAUX_SetWindowText(FAUX_GetParent(FAUX_GetParent(SELF.hWnd)),szWinTitle)
        IF SELF.VScroll THEN POST(EVENT:VScrollOn,0,1,TRUE).
        IF SELF.HScroll THEN POST(EVENT:HScrollOn,0,1,TRUE).
      END
      
      SELF.MyMaximize = 0 ; SELF.GlobalMaximize = 0
   END
   POST(EVENT:Selected,FOCUS())
   
   If SELF.WRC &= NULL
      POST(Event:Sized)
   Else
      SELF.WRC.Resize()
   End
   
   Return 5 !Level:Notify don't call next event handler or accept

FauxMaxClass.OnResize    Procedure()!,Byte,Protected,Proc

rcFCA       Like(FAUX_RECT)
szWinTitle  CSTRING(192)

   CODE
   
   FAUX_GetWindowRect(FAUX_GetParent(SELF.hWnd), rcFCA)

   IF (SELF.MyMaximize = 1)
      IF SELF.MDIBorder<>3
        szWinTitle = SELF.OrigTitle & ' - ' & SELF.W{PROP:Text}
        FAUX_SetWindowText(FAUX_GetParent(FAUX_GetParent(SELF.hWnd)),szWinTitle)
        IF SELF.VScroll THEN POST(EVENT:VScrollOff,0,1,TRUE).
        IF SELF.HScroll THEN POST(EVENT:HScrollOff,0,1,TRUE).
      END
      FAUX_MoveWindow(SELF.hWnd, -SELF.ltBorder, -SELF.tpBorder, (rcFCA.Right - rcFCA.Left + SELF.rtBorder), (rcFCA.Bottom - rcFCA.Top + SELF.bmBorder), True)
   END
   
   If SELF.WRC &= NULL
      POST(Event:Sized)
   Else
      SELF.WRC.Resize()
   End
   
   Return Level:Benign !allow event handler processing to continue
